diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
index eaa4805ec..bba919c71 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
@@ -11,10 +11,10 @@ import net.minecraft.core.world.World;
 import java.util.Random;
 
 public class ItemDoor extends Item {
-	protected final Block doorBlockBottom;
-	protected final Block doorBlockTop;
+	protected final Block<?> doorBlockBottom;
+	protected final Block<?> doorBlockTop;
 
-	public ItemDoor(String name, String namespaceId, int id, Block doorBlockBottom, Block doorBlockTop) {
+	public ItemDoor(String name, String namespaceId, int id, Block<?> doorBlockBottom, Block<?> doorBlockTop) {
 		super(name, namespaceId, id);
 		maxStackSize = 64;
         this.doorBlockBottom = doorBlockBottom;
@@ -40,8 +40,8 @@ public class ItemDoor extends Item {
 
 		int isSolidBlockLeft = (world.isBlockNormalCube(blockX - xOffset, blockY, blockZ - zOffset) ? 1 : 0) + (world.isBlockNormalCube(blockX - xOffset, blockY + 1, blockZ - zOffset) ? 1 : 0);
 		int isSolidBlockRight = (world.isBlockNormalCube(blockX + xOffset, blockY, blockZ + zOffset) ? 1 : 0) + (world.isBlockNormalCube(blockX + xOffset, blockY + 1, blockZ + zOffset) ? 1 : 0);
-		boolean isDoorLeft = world.getBlockId(blockX - xOffset, blockY, blockZ - zOffset) == doorBlockBottom.id || world.getBlockId(blockX - xOffset, blockY + 1, blockZ - zOffset) == doorBlockTop.id;
-		boolean isDoorRight = world.getBlockId(blockX + xOffset, blockY, blockZ + zOffset) == doorBlockBottom.id || world.getBlockId(blockX + xOffset, blockY + 1, blockZ + zOffset) == doorBlockTop.id;
+		boolean isDoorLeft = world.getBlockId(blockX - xOffset, blockY, blockZ - zOffset) == doorBlockBottom.id() || world.getBlockId(blockX - xOffset, blockY + 1, blockZ - zOffset) == doorBlockTop.id();
+		boolean isDoorRight = world.getBlockId(blockX + xOffset, blockY, blockZ + zOffset) == doorBlockBottom.id() || world.getBlockId(blockX + xOffset, blockY + 1, blockZ + zOffset) == doorBlockTop.id();
 		boolean isMirrored = false;
 		
 		if(isDoorLeft && !isDoorRight) {
@@ -56,11 +56,11 @@ public class ItemDoor extends Item {
 		}
 		
 		world.noNeighborUpdate = true;
-		world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, doorBlockBottom.id, meta);
-		world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, doorBlockTop.id, meta);
+		world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, doorBlockBottom.id(), meta);
+		world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, doorBlockTop.id(), meta);
 		world.noNeighborUpdate = false;
-		world.notifyBlocksOfNeighborChange(blockX, blockY, blockZ, doorBlockBottom.id);
-		world.notifyBlocksOfNeighborChange(blockX, blockY + 1, blockZ, doorBlockTop.id);
+		world.notifyBlocksOfNeighborChange(blockX, blockY, blockZ, doorBlockBottom.id());
+		world.notifyBlocksOfNeighborChange(blockX, blockY + 1, blockZ, doorBlockTop.id());
 		world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, doorBlockBottom, EnumBlockSoundEffectType.PLACE);
 		doorBlockBottom.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, xPlaced, yPlaced);
 		doorBlockTop.onBlockPlacedByMob(world, blockX, blockY + 1, blockZ, side, player, xPlaced, yPlaced);
@@ -88,8 +88,8 @@ public class ItemDoor extends Item {
 
 		int isSolidBlockLeft = (world.isBlockNormalCube(blockX - xOffset, blockY, blockZ - zOffset) ? 1 : 0) + (world.isBlockNormalCube(blockX - xOffset, blockY + 1, blockZ - zOffset) ? 1 : 0);
 		int isSolidBlockRight = (world.isBlockNormalCube(blockX + xOffset, blockY, blockZ + zOffset) ? 1 : 0) + (world.isBlockNormalCube(blockX + xOffset, blockY + 1, blockZ + zOffset) ? 1 : 0);
-		boolean isDoorLeft = world.getBlockId(blockX - xOffset, blockY, blockZ - zOffset) == doorBlockBottom.id || world.getBlockId(blockX - xOffset, blockY + 1, blockZ - zOffset) == doorBlockTop.id;
-		boolean isDoorRight = world.getBlockId(blockX + xOffset, blockY, blockZ + zOffset) == doorBlockBottom.id || world.getBlockId(blockX + xOffset, blockY + 1, blockZ + zOffset) == doorBlockTop.id;
+		boolean isDoorLeft = world.getBlockId(blockX - xOffset, blockY, blockZ - zOffset) == doorBlockBottom.id() || world.getBlockId(blockX - xOffset, blockY + 1, blockZ - zOffset) == doorBlockTop.id();
+		boolean isDoorRight = world.getBlockId(blockX + xOffset, blockY, blockZ + zOffset) == doorBlockBottom.id() || world.getBlockId(blockX + xOffset, blockY + 1, blockZ + zOffset) == doorBlockTop.id();
 		boolean isMirrored = false;
 
 		if(isDoorLeft && !isDoorRight) {
@@ -104,11 +104,11 @@ public class ItemDoor extends Item {
 		}
 
 		world.noNeighborUpdate = true;
-		world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, doorBlockBottom.id, meta);
-		world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, doorBlockTop.id, meta);
+		world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, doorBlockBottom.id(), meta);
+		world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, doorBlockTop.id(), meta);
 		world.noNeighborUpdate = false;
-		world.notifyBlocksOfNeighborChange(blockX, blockY, blockZ, doorBlockBottom.id);
-		world.notifyBlocksOfNeighborChange(blockX, blockY + 1, blockZ, doorBlockTop.id);
+		world.notifyBlocksOfNeighborChange(blockX, blockY, blockZ, doorBlockBottom.id());
+		world.notifyBlocksOfNeighborChange(blockX, blockY + 1, blockZ, doorBlockTop.id());
 		world.playBlockSoundEffect(null, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, doorBlockBottom, EnumBlockSoundEffectType.PLACE);
 		doorBlockBottom.onBlockPlacedOnSide(world, blockX, blockY, blockZ, direction.getSide(), 0.5, 0.5);
 		doorBlockTop.onBlockPlacedOnSide(world, blockX, blockY + 1, blockZ, direction.getSide(), 0.5, 0.5);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDoorPainted.java b/game/core/src/main/java/net/minecraft/core/item/ItemDoorPainted.java
index 79afeb75b..0b53ff9e3 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDoorPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDoorPainted.java
@@ -9,7 +9,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 public class ItemDoorPainted extends ItemDoor {
-    public ItemDoorPainted(String name, String namespaceId, int id, Block doorBottom, Block doorTopId) {
+    public ItemDoorPainted(String name, String namespaceId, int id, Block<?> doorBottom, Block<?> doorTopId) {
         super(name, namespaceId, id, doorBottom, doorTopId);
     }
     @Override
@@ -31,8 +31,8 @@ public class ItemDoorPainted extends ItemDoor {
 
         int isSolidBlockLeft = (world.isBlockNormalCube(blockX - xOffset, blockY, blockZ - zOffset) ? 1 : 0) + (world.isBlockNormalCube(blockX - xOffset, blockY + 1, blockZ - zOffset) ? 1 : 0);
         int isSolidBlockRight = (world.isBlockNormalCube(blockX + xOffset, blockY, blockZ + zOffset) ? 1 : 0) + (world.isBlockNormalCube(blockX + xOffset, blockY + 1, blockZ + zOffset) ? 1 : 0);
-        boolean isDoorLeft = world.getBlockId(blockX - xOffset, blockY, blockZ - zOffset) == doorBlockBottom.id || world.getBlockId(blockX - xOffset, blockY + 1, blockZ - zOffset) == doorBlockTop.id;
-        boolean isDoorRight = world.getBlockId(blockX + xOffset, blockY, blockZ + zOffset) == doorBlockBottom.id || world.getBlockId(blockX + xOffset, blockY + 1, blockZ + zOffset) == doorBlockTop.id;
+        boolean isDoorLeft = world.getBlockId(blockX - xOffset, blockY, blockZ - zOffset) == doorBlockBottom.id() || world.getBlockId(blockX - xOffset, blockY + 1, blockZ - zOffset) == doorBlockTop.id();
+        boolean isDoorRight = world.getBlockId(blockX + xOffset, blockY, blockZ + zOffset) == doorBlockBottom.id() || world.getBlockId(blockX + xOffset, blockY + 1, blockZ + zOffset) == doorBlockTop.id();
         boolean isMirrored = false;
 
         if(isDoorLeft && !isDoorRight) {
@@ -48,11 +48,11 @@ public class ItemDoorPainted extends ItemDoor {
         meta |= (15 - itemstack.getMetadata()) << 4 &0xF0;
 
         world.noNeighborUpdate = true;
-        world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, doorBlockBottom.id, meta);
-        world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, doorBlockTop.id, meta);
+        world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, doorBlockBottom.id(), meta);
+        world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, doorBlockTop.id(), meta);
         world.noNeighborUpdate = false;
-        world.notifyBlocksOfNeighborChange(blockX, blockY, blockZ, doorBlockBottom.id);
-        world.notifyBlocksOfNeighborChange(blockX, blockY + 1, blockZ, doorBlockTop.id);
+        world.notifyBlocksOfNeighborChange(blockX, blockY, blockZ, doorBlockBottom.id());
+        world.notifyBlocksOfNeighborChange(blockX, blockY + 1, blockZ, doorBlockTop.id());
         world.playBlockSoundEffect(player,blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, doorBlockBottom, EnumBlockSoundEffectType.PLACE);
         itemstack.consumeItem(player);
         return true;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDye.java b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
index cb6c392bf..175a52360 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
@@ -40,7 +40,7 @@ public class ItemDye extends Item
     @Override
     public boolean onUseItemOnBlock(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
-        if (world.getBlockId(blockX, blockY, blockZ) == Blocks.SIGN_POST_PLANKS_OAK.id || world.getBlockId(blockX, blockY, blockZ) == Blocks.SIGN_WALL_PLANKS_OAK.id)
+        if (world.getBlockId(blockX, blockY, blockZ) == Blocks.SIGN_POST_PLANKS_OAK.id() || world.getBlockId(blockX, blockY, blockZ) == Blocks.SIGN_WALL_PLANKS_OAK.id())
         {
             TileEntitySign sign = (TileEntitySign) world.getBlockEntity(blockX, blockY, blockZ);
             if ((DyeColor.WHITE.itemMeta - itemstack.getMetadata()) != sign.getColor().id)
@@ -57,20 +57,20 @@ public class ItemDye extends Item
         if(itemstack.getMetadata() == DyeColor.WHITE.itemMeta)
         {
             int id = world.getBlockId(blockX, blockY, blockZ);
-            Block block = Blocks.blocksList[id];
-            if (block instanceof IBonemealable){
-               if (((IBonemealable) block).onBonemealUsed(itemstack, player, world, blockX, blockY, blockZ, side, xPlaced, yPlaced)){
+            Block<?> block = Blocks.blocksList[id];
+            if (Block.hasLogicClass(block, IBonemealable.class)){
+               if (((IBonemealable) block.getLogic()).onBonemealUsed(itemstack, player, world, blockX, blockY, blockZ, side, xPlaced, yPlaced)){
                    return true;
                }
             }
-            if(id == Blocks.DIRT.id)
+            if(id == Blocks.DIRT.id())
             {
                 if(!world.isClientSide)
                 {
                     if(Blocks.lightBlock[world.getBlockId(blockX, blockY + 1, blockZ)] <= 2) {
-                    	int grass = Blocks.GRASS.id;
+                    	int grass = Blocks.GRASS.id();
                     	if(world.dimensionData.getWorldType() == WorldTypes.OVERWORLD_RETRO) {
-                    		grass = Blocks.GRASS_RETRO.id;
+                    		grass = Blocks.GRASS_RETRO.id();
                     	}
                         world.setBlockWithNotify(blockX, blockY, blockZ, grass);
                         if (player == null || player.getGamemode().consumeBlocks())
@@ -81,12 +81,12 @@ public class ItemDye extends Item
                 }
                 return true;
             }
-            if(id == Blocks.DIRT_SCORCHED.id)
+            if(id == Blocks.DIRT_SCORCHED.id())
             {
                 if (!world.isClientSide)
                 {
                     if(Blocks.lightBlock[world.getBlockId(blockX, blockY + 1, blockZ)] <= 2) {
-                        int grass = Blocks.GRASS_SCORCHED.id;
+                        int grass = Blocks.GRASS_SCORCHED.id();
                         world.setBlockWithNotify(blockX, blockY, blockZ, grass);
                         if (player == null || player.getGamemode().consumeBlocks())
                         {
@@ -129,27 +129,27 @@ label0:
                         }
                         if(itemRand.nextInt(10) != 0)
                         {
-                            if(world.getBlockId(k1, l1-1, i2) == Blocks.DIRT_SCORCHED.id ||
-                                    world.getBlockId(k1, l1-1, i2) == Blocks.DIRT_SCORCHED_RICH.id)
-                                world.setBlockWithNotify(k1, l1, i2, Blocks.SPINIFEX.id);
+                            if(world.getBlockId(k1, l1-1, i2) == Blocks.DIRT_SCORCHED.id() ||
+                                    world.getBlockId(k1, l1-1, i2) == Blocks.DIRT_SCORCHED_RICH.id())
+                                world.setBlockWithNotify(k1, l1, i2, Blocks.SPINIFEX.id());
                             else
-                                world.setBlockWithNotify(k1, l1, i2, Blocks.TALLGRASS.id);
+                                world.setBlockWithNotify(k1, l1, i2, Blocks.TALLGRASS.id());
                             continue;
                         }
                         int r = itemRand.nextInt(12);
                         Biome biome = world.getBlockBiome(k1, l1, i2);
                         if (r < 1){
-                            world.setBlockWithNotify(k1, l1, i2, Blocks.FLOWER_YELLOW.id);
+                            world.setBlockWithNotify(k1, l1, i2, Blocks.FLOWER_YELLOW.id());
                         } else if (r < 2) {
-                            world.setBlockWithNotify(k1, l1, i2, Blocks.FLOWER_RED.id);
+                            world.setBlockWithNotify(k1, l1, i2, Blocks.FLOWER_RED.id());
                         } else if (r < 4 && (biome == Biomes.OVERWORLD_BIRCH_FOREST || biome == Biomes.OVERWORLD_SEASONAL_FOREST)) {
-                            world.setBlockWithNotify(k1, l1, i2, Blocks.FLOWER_PINK.id);
+                            world.setBlockWithNotify(k1, l1, i2, Blocks.FLOWER_PINK.id());
                         } else if (r < 6 && (biome == Biomes.OVERWORLD_MEADOW || biome == Biomes.OVERWORLD_BOREAL_FOREST || biome == Biomes.OVERWORLD_SHRUBLAND)) {
-                            world.setBlockWithNotify(k1, l1, i2, Blocks.FLOWER_PURPLE.id);
+                            world.setBlockWithNotify(k1, l1, i2, Blocks.FLOWER_PURPLE.id());
                         } else if (r < 8 && (biome == Biomes.OVERWORLD_FOREST || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_RAINFOREST || biome == Biomes.OVERWORLD_GRASSLANDS || biome == Biomes.OVERWORLD_CAATINGA)) {
-                            world.setBlockWithNotify(k1, l1, i2, Blocks.FLOWER_LIGHT_BLUE.id);
+                            world.setBlockWithNotify(k1, l1, i2, Blocks.FLOWER_LIGHT_BLUE.id());
                         } else if (r < 10 && (biome == Biomes.OVERWORLD_PLAINS || biome == Biomes.OVERWORLD_GRASSLANDS || biome == Biomes.OVERWORLD_OUTBACK || biome == Biomes.OVERWORLD_OUTBACK_GRASSY)) {
-                            world.setBlockWithNotify(k1, l1, i2, Blocks.FLOWER_ORANGE.id);
+                            world.setBlockWithNotify(k1, l1, i2, Blocks.FLOWER_ORANGE.id());
                         }
                     }
                 }
@@ -165,13 +165,13 @@ label0:
     }
 
     @Override
-    public boolean useItemOnEntity(ItemStack itemstack, Mob mob, Player entityPlayer)
+    public boolean useItemOnEntity(ItemStack itemstack, Mob mob, Player player)
     {
         if(mob instanceof MobSheep)
         {
             MobSheep mobSheep = (MobSheep)mob;
             DyeColor woolColor = DyeColor.colorFromItemMeta(itemstack.getMetadata());
-            if(mobSheep.getFleeceColor() != woolColor && itemstack.consumeItem(entityPlayer))
+            if(mobSheep.getFleeceColor() != woolColor && itemstack.consumeItem(player))
             {
                 mobSheep.setFleeceColor(woolColor);
                 return true;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java b/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java
index 1a78d77de..593c81c89 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockBrazier;
-import net.minecraft.core.block.BlockFluid;
-import net.minecraft.core.block.BlockTNT;
+import net.minecraft.core.block.BlockLogicBrazier;
+import net.minecraft.core.block.BlockLogicFluid;
+import net.minecraft.core.block.BlockLogicTNT;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.material.ToolMaterial;
@@ -34,7 +34,7 @@ public class ItemFireStriker extends Item
         int i1 = world.getBlockId(blockX, blockY, blockZ);
         if(i1 == 0)
         {
-            if(world.setBlockWithNotify(blockX, blockY, blockZ, Blocks.FIRE.id)){
+            if(world.setBlockWithNotify(blockX, blockY, blockZ, Blocks.FIRE.id())){
                 world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D, "fire.ignite", 1.0F, itemRand.nextFloat() * 0.4F + 0.8F);
                 itemstack.damageItem(1, entityplayer);
                 return true;
@@ -50,19 +50,19 @@ public class ItemFireStriker extends Item
             blockX += direction.getOffsetX();
             blockY += direction.getOffsetY();
             blockZ += direction.getOffsetZ();
-            Block b = world.getBlock(blockX, blockY, blockZ);
-            if (b instanceof BlockBrazier && !((BlockBrazier)b).isBurning()) {
-                if (world.getBlock(blockX + 1,  blockY, blockZ) instanceof BlockFluid ||
-                    world.getBlock(blockX - 1,  blockY, blockZ) instanceof BlockFluid ||
-                    world.getBlock(blockX,      blockY, blockZ + 1) instanceof BlockFluid ||
-                    world.getBlock(blockX,      blockY, blockZ - 1) instanceof BlockFluid) {
+            Block<?> b = world.getBlock(blockX, blockY, blockZ);
+            if (Block.hasLogicClass(b, BlockLogicBrazier.class) && !(((BlockLogicBrazier)(b.getLogic())).isBurning())) {
+                if (Block.hasLogicClass(world.getBlock(blockX + 1,  blockY, blockZ), BlockLogicFluid.class) ||
+                    Block.hasLogicClass(world.getBlock(blockX - 1,  blockY, blockZ), BlockLogicFluid.class) ||
+                    Block.hasLogicClass(world.getBlock(blockX,  blockY, blockZ + 1), BlockLogicFluid.class) ||
+                    Block.hasLogicClass(world.getBlock(blockX,  blockY, blockZ - 1), BlockLogicFluid.class)) {
                     return;
                 }
-                world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.BRAZIER_ACTIVE.id, 0);
+                world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.BRAZIER_ACTIVE.id(), 0);
                 itemStack.damageItem(1, null);
                 world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D, "fire.ignite", 1.0F, world.rand.nextFloat() * 0.4F + 0.8F);
-            } else if (b instanceof BlockTNT) {
-                ((BlockTNT)b).ignite(world, blockX, blockY, blockZ, true);
+            } else if (Block.hasLogicClass(b, BlockLogicTNT.class)) {
+                ((BlockLogicTNT)b.getLogic()).ignite(world, blockX, blockY, blockZ, true);
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java b/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
index 50ee6e1bb..70c0d2f9f 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
@@ -32,7 +32,7 @@ public class ItemFlag extends Item
     public boolean onUseItemOnBlock(ItemStack stack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         // copy flag data to empty flag
-		if (world.getBlockId(blockX, blockY, blockZ) == Blocks.FLAG.id && !entityplayer.isSneaking()) {
+		if (world.getBlockId(blockX, blockY, blockZ) == Blocks.FLAG.id() && !entityplayer.isSneaking()) {
 			TileEntityFlag flag = (TileEntityFlag) world.getBlockEntity(blockX, blockY, blockZ);
 			if (flag != null) {
 				CompoundTag flagData = stack.getData().getCompoundOrDefault("FlagData", new CompoundTag());
@@ -71,7 +71,7 @@ public class ItemFlag extends Item
         }
 
         world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.FLAG, EnumBlockSoundEffectType.PLACE);
-        world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.FLAG.id, 0);
+        world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.FLAG.id(), 0);
         
         stack.consumeItem(entityplayer);
         TileEntityFlag tileEntityFlag = (TileEntityFlag) world.getBlockEntity(blockX, blockY, blockZ);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemMap.java b/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
index 044790b29..422979c86 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.item;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.block.material.Material;
@@ -121,7 +120,7 @@ public class ItemMap extends Item implements IComplexItem
 	}
 	@Override
 	public boolean onUseItemOnBlock(ItemStack itemstack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
-		if (world.getBlockId(blockX, blockY, blockZ) == Blocks.FLAG.id) {
+		if (world.getBlockId(blockX, blockY, blockZ) == Blocks.FLAG.id()) {
 			ItemMapSavedData mapData = getOrCreateSavedData(itemstack, world);
 			if (mapData != null){
 				TileEntityFlag flag = (TileEntityFlag) world.getBlockEntity(blockX, blockY, blockZ);
@@ -200,11 +199,11 @@ public class ItemMap extends Item implements IComplexItem
 					int rand = blockX + blockZ * 0x389bf;
 					rand = rand * rand * 0x1dd6751 + rand * 11;
 					if((rand >> 20 & 1) == 0) {
-						blockCounts.putIfAbsent(Blocks.DIRT.id, new HashMap<>());
-						blockCounts.get(Blocks.DIRT.id).put(-1, blockCounts.get(Blocks.DIRT.id).getOrDefault(-1, 0) + 10);
+						blockCounts.putIfAbsent(Blocks.DIRT.id(), new HashMap<>());
+						blockCounts.get(Blocks.DIRT.id()).put(-1, blockCounts.get(Blocks.DIRT.id()).getOrDefault(-1, 0) + 10);
 					} else {
-						blockCounts.putIfAbsent(Blocks.STONE.id, new HashMap<>());
-						blockCounts.get(Blocks.STONE.id).put(-1, blockCounts.get(Blocks.STONE.id).getOrDefault(-1, 0) + 10);
+						blockCounts.putIfAbsent(Blocks.STONE.id(), new HashMap<>());
+						blockCounts.get(Blocks.STONE.id()).put(-1, blockCounts.get(Blocks.STONE.id()).getOrDefault(-1, 0) + 10);
 					}
 					pixelHeight = 100D;
 				} else {
@@ -218,16 +217,16 @@ public class ItemMap extends Item implements IComplexItem
 								do {
 									runLoop = false;
 									id = chunk.getBlockID(_x + blockInChunkX, height, _z + blockInChunkZ);
-									if(id <= 0 || (height > 0 && Blocks.blocksList[id].blockMaterial.color == MaterialColor.none)) {
+									if(id <= 0 || (height > 0 && Blocks.blocksList[id].getMaterial().color == MaterialColor.none)) {
 										runLoop = true;
 										height--;
 									}
 								} while (runLoop);
-								if(Blocks.blocksList[id].blockMaterial == Material.water) {
+								if(Blocks.blocksList[id].getMaterial() == Material.water) {
 									int _y = height;
                                     int _blockID = chunk.getBlockID(_x + blockInChunkX, _y--, _z + blockInChunkZ);
                                     waterDepth++;
-                                    while (_y > 0 && _blockID > 0 && Blocks.blocksList[_blockID].blockMaterial == Material.water) {
+                                    while (_y > 0 && _blockID > 0 && Blocks.blocksList[_blockID].getMaterial() == Material.water) {
                                         _blockID = chunk.getBlockID(_x + blockInChunkX, _y--, _z + blockInChunkZ);
                                         waterDepth++;
                                     }
@@ -270,7 +269,7 @@ public class ItemMap extends Item implements IComplexItem
 				
 				int colorIndex = 0;
 				if(id > 0) {
-					MaterialColor mapcolor = Blocks.blocksList[id].blockMaterial.color;
+					MaterialColor mapcolor = Blocks.blocksList[id].getMaterial().color;
 					if(mapcolor == MaterialColor.water) {
 						double d3 = (double) waterDepth * 0.1D + (double) (x + z & 1) * 0.2D;
 						brightness = 1;
@@ -372,7 +371,7 @@ public class ItemMap extends Item implements IComplexItem
 		}
 		return null;
     }
-    
+
     @Override
     public String getTranslatedName(ItemStack itemstack) {
 		if (!hasInitialized(itemstack)) return I18n.getInstance().translateKey(itemstack.getItemKey() + ".blank.name");
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java b/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java
index 7bbacc395..83e29e168 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java
@@ -2,8 +2,8 @@ package net.minecraft.core.item;
 
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockRail;
 
+import net.minecraft.core.block.BlockLogicRail;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.vehicle.MinecartEntity;
@@ -24,8 +24,8 @@ public class ItemMinecart extends Item {
 
     @Override
     public boolean onUseItemOnBlock(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
-        Block block = world.getBlock(blockX, blockY, blockZ);
-        if (!(block instanceof BlockRail)) { return false; }
+        Block<?> block = world.getBlock(blockX, blockY, blockZ);
+        if (!Block.hasLogicClass(block, BlockLogicRail.class)) { return false; }
 
         if(!world.isClientSide) {
             world.entityJoinedWorld(new MinecartEntity(world, (float) blockX + 0.5F, (float) blockY + 0.5F, (float) blockZ + 0.5F, minecartType));
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java b/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
index 79d9dac51..f3a75adf5 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
@@ -32,10 +32,10 @@ public class ItemPaintBrush extends Item {
         }
 
         final int id = world.getBlockId(blockX, blockY, blockZ);
-        final Block block = Blocks.getBlock(id);
+        final Block<?> block = Blocks.getBlock(id);
 
-        if (block instanceof IPaintable) {
-            final IPaintable paintable = (IPaintable) block;
+        if (Block.hasLogicClass(block, IPaintable.class)) {
+            final IPaintable paintable = (IPaintable) block.getLogic();
             if (!paintable.canBePainted()) return false;
             final DyeColor color = getColor(itemstack);
             if (color != null) {
